# zope
from Globals import InitializeClass
from Products.PageTemplates.PageTemplateFile import PageTemplateFile

# silva
from Products.Silva.Document import Document
from Products.Silva.helpers import add_and_edit

# silva local content
from interfaces import ILocalVersionedContent
from LocalVersionedContent import LocalVersionedContent

icon = 'www/silvadoc.gif'
class LocalDocument(LocalVersionedContent, Document):

    __implements__ = (ILocalVersionedContent,)

    meta_type = 'Silva Local Document'

    def __init__(self, id, title, language):
        LocalDocument.inheritedAttribute('__init__')(self, id, title, language)
    
InitializeClass(LocalDocument)


manage_addLocalDocumentForm = PageTemplateFile("www/documentAdd.zpt", globals(),
                                               __name__='manage_addLocalDocumentForm')

def manage_addLocalDocument(self, id, title, REQUEST=None):
    """Add a Locale Document."""

    if not self.is_id_valid(id):
        return

    language = self.get_selected_language()
    object = LocalDocument(id, title, language=language)
    self._setObject(id, object)
    object = getattr(self, id)
    content = '<doc />'
    # create a new version object; the following is a shortcut for:
    #object._get_lang_content_writeable((language).manage_addProduct['ParsedXML'].manage_addParsedXML('0', '', content)
    object._create_initial_xml_version(content)

    add_and_edit(self, id, REQUEST)
    return ''
