
# some helpers for nicer testing

import Zope
import Globals
from Testing.makerequest import makerequest
from Products.Silva.tests.test_SilvaObject import hack_create_user as create_user

from Products.SilvaLocalContent.LocalSilvaObject import LocalSilvaObject
from Products.SilvaLocalContent.util import AcceptLanguageFake

import zLOG

zLOG.LOG('SilvaLocalContent.tests', 0,
         'monkey patching for unittests; I hope You are really unittesting now ...')

# necessary monkeys to the Globals "get_request" :(

# ... import localizer, for its monkeys come first ...
import Products.Localizer 

my_request = None
def Globals_get_request():
    #raise RuntimeError, 'get request'
    return my_request

Globals.get_request = Globals_get_request
# FIXME: who else may have imported this already before the monkey could patch it ?
import Products.Localizer.Utils
Products.Localizer.Utils.get_request = Globals_get_request

def test_request(connection, lang='en'):
    root = makerequest(connection.root()['Application'])
    request = root.REQUEST
    request['URL1']='/root'
    global my_request
    my_request = request
    create_user(root)
    # hm, really use "en" as default ?
    root.REQUEST.set('AcceptLanguage', AcceptLanguageFake(lang))
    return root



# monkeys to cheat the permission machinery
#
LocalSilvaObject.manage_fixupOwnershipAfterAdd = lambda self: None


def assert_equal_elements(seq1, seq2):
    """ helper test, if two sequences contain the same elements
    even if in a different order
    """
    for x in seq1:
        if x not in seq2:
            raise AssertionError('%s not in sequence.\nexpected sequence: %s\ngot sequence %s' %\
                      (x, seq1, seq2))
    for y in seq2:
        if y not in seq1:
            raise AssertionError('%s too much in sequence.\nexpected sequence: %s\ngot sequence %s' %\
                      (y, seq1, seq2))
